DROP TABLE IF EXISTS api_tokens;
CREATE TABLE IF NOT EXISTS api_tokens (
  id BIGSERIAL,
  name VARCHAR(127) NOT NULL ,
  value VARCHAR(1023) NOT NULL,
  expires_at TIMESTAMP NULL,
  last_used_at TIMESTAMP NULL,
  user_id BIGINT NOT NULL,
  PRIMARY KEY (id),
  UNIQUE (user_id, name),
  UNIQUE (value, user_id),
  FOREIGN KEY (user_id) REFERENCES users
);

DROP TABLE IF EXISTS refresh_tokens;
CREATE TABLE IF NOT EXISTS refresh_tokens (
  id BIGSERIAL,
  value VARCHAR(1023) NOT NULL,
  expires_at TIMESTAMP NULL,
  user_agent_header VARCHAR(2047) NULL,
  ip_address VARCHAR(127) NULL,
  user_id BIGINT NOT NULL,
  PRIMARY KEY (id),
  UNIQUE (value, user_id),
  FOREIGN KEY (user_id) REFERENCES users
);
CREATE INDEX refresh_token_user_id_idx ON refresh_tokens (user_id);

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:api-tokens:read')
ON CONFLICT DO NOTHING;

INSERT INTO PERMISSIONS (NAME)
VALUES ('iam:api-tokens:revoke')
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
VALUES ((SELECT ID FROM GROUPS WHERE NAME = 'Super admins'), (SELECT ID FROM PERMISSIONS WHERE NAME = 'iam:api-tokens:read'))
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
VALUES ((SELECT ID FROM GROUPS WHERE NAME = 'Super admins'), (SELECT ID FROM PERMISSIONS WHERE NAME = 'iam:api-tokens:revoke'))
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
VALUES ((SELECT ID FROM GROUPS WHERE NAME = 'Admins'), (SELECT ID FROM PERMISSIONS WHERE NAME = 'iam:api-tokens:read'))
ON CONFLICT DO NOTHING;

INSERT INTO GROUP_PERMISSIONS (GROUP_ID, PERMISSION_ID)
VALUES ((SELECT ID FROM GROUPS WHERE NAME = 'Admins'), (SELECT ID FROM PERMISSIONS WHERE NAME = 'iam:api-tokens:revoke'))
ON CONFLICT DO NOTHING;

CREATE SCHEMA IF NOT EXISTS _system;
CREATE EXTENSION IF NOT EXISTS pgcrypto schema _system;
